// let localEnv = "local";
// let localEnv = "dev";
let localEnv = "prod";



const KlineIntervalEnum = {
  SecondOne: 1*1000,//1000,
  MinuteOne: 1*60*1000,//60000,
  MinuteThree: 3*60*1000,//180000,
  MinuteFive: 5*60*1000,//300000,
  MinuteTen: 10*60*1000,//600000,
  MinuteFifteen: 15*60*1000,//900000,
  MinuteThirty: 30*60*1000,//1800000,
  HourOne: 1*60*60*1000,//3600000
  HourFour: 4*60*60*1000,//14400000
  HourTwelve: 12*60*60*1000,//43200000
  DayOne: 1*24*60*60*1000,//86400000
  DayThree: 3*24*60*60*1000,//259200000
  WeekOne: 1*7*24*60*60*1000,//604800000
  WeekTwo: 2*7*24*60*60*1000,//604800000
  MonthOne: 30*24*60*60*1000,//604800000
}


let swiperinoDomain = "https://swiperino.com";
let swiperinoApiDomain = "https://api.swiperino.com";
if(localEnv === "local"){
  swiperinoDomain = "http://localhost:8888";
  swiperinoApiDomain = "http://localhost:3060";
}else if(localEnv === "dev"){
  swiperinoDomain = "https://testswiperino.com";
  swiperinoApiDomain = "https://api.testswiperino.com";
}

// lsa
// dsa
// rd

let swiperinoStatus = "idle";
let activeApps = [];
let currentWindow = "None";
let activeTab = null;
let elementStirngs = {};
let likesRemaining = null;

let nextCommand = null;
let taskList = [];

let currentSettings = {};
let sleepTimeDateGlobal = null;
let wakeTimeDateGlobal = null;

let appEnum = {
	Tinder:{
		Url: "https://tinder.com/app/recs",
	},
	Bumble:{
		Url: "https://bumble.com/app",
	},
	Badoo:{
		Url: "https://badoo.com/encounters",
	},
}


chrome.runtime.onMessage.addListener(async function(request, sender, sendResponse) {
	// console.log("request",request);
	// console.log("sender",sender);
	// console.log("sendResponse",sendResponse);
	// console.log("activeTab",activeTab);
	// console.log("messaged");

	if(request.command === "fetch-next-command"){
		sendResponse(nextCommand);
		nextCommand = null;
	}else if(request.command === "shift-task-list"){
		taskList.shift()
	}else if(request.command === "fetch-task-list"){
		sendResponse({result: "success", taskList});
	}else if(request.command === "get-status"){
		sendResponse({result: "success", swiperinoStatus});
		return;
	}else if(request.command === "toggle-start-top"){
		toggleSwiperino(request.apps,request.appActivity,request.swipeNumber,request.sleepTime,request.wakeTime);
	}


	if(request && request.results && request.type){
		let type = request.type;
		let results = request.results;
		if(type === "authAPIKey"){
			elementStirngs = results.es;
			likesRemaining = results.lr;
		}else if(type === "sendTouchCommand"){
			let {x,y} = request.results;
			console.log("trigger touchcommand");
			if(activeTab){
				sendTouchCommand(activeTab.id,x,y);
			}
		}else if(type === "sendTextCommand"){
			let {x,y,newText} = request.results;
			if(activeTab){
				sendTextCommand(activeTab.id,x,y,newText);
			}
		}

		// console.log("type",type);
		// console.log("results",results);
	}


	sendResponse({result: "success"});

});


chrome.tabs.onActivated.addListener(function(activeInfo) {
	updateCurrentTab();
});

chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
	updateCurrentTab();
})


const updateCurrentTab = () => {
	console.log("updateCurrentTab")
	chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {

		let tabId = activeTab?activeTab.id:null;
		// if(tabId){
		// 	chrome.debugger.detach({tabId: tabId},() => {
		// 		console.log("detached");
		// 	});
		// }
		
		activeTab = tabs[0];
		if(activeTab && activeTab.url){
			if(activeTab.url.includes("tinder.com")){
				currentWindow = "Tinder";
			}else if(activeTab.url.includes("bumble.com")){
				currentWindow = "Bumble";
				// chrome.debugger.attach({tabId: activeTab.id},"1.2",() => {});
			}else{
				currentWindow = "None";
			}
			console.log("currentWindow",currentWindow)
		}


    // chrome.scripting.executeScript({
	  //   target: { tabId: activeTab.id },
	  //   files: ['geo.js']
    // });
		
		// console.log("currentWindow",currentWindow);
		// console.log("activeTab",activeTab);
	});
}

// x: 675,
// y: 660,



// const sendTouchCommand = (tabId,x,y) => {
// 	console.log("sendTouchCommand")
// 	console.log("tabId",tabId)
// 	console.log("x",x);
// 	console.log("y",y);

// 	chrome.debugger.attach({tabId: tabId}, '1.0', function() {
// 		setTimeout(() => {

// 		},100);
// 		chrome.debugger.sendCommand({tabId: tabId}, 'Input.dispatchMouseEvent', {
// 			type: 'mousePressed',
// 			x: x,
// 			y: y,
// 			button: 'left',
// 			clickCount: 1
// 		}, function() {
// 			chrome.debugger.sendCommand({tabId: tabId}, 'Input.dispatchMouseEvent', {
// 				type: 'mouseReleased',
// 				x: x,
// 				y: y,
// 				button: 'left',
// 				clickCount: 1
// 			}, function() {
// 				chrome.debugger.detach({tabId: tabId});
// 			});
// 		});
// 	});
// }


const sendTouchCommandHold = (tabId,x,y) => {
	console.log("sendTouchCommand")
	console.log("tabId",tabId)
	console.log("x",x);
	console.log("y",y);

	// chrome.debugger.attach({tabId: tabId},"1.3",() => {
  	let touchPoint = {
			x: x,
			y: y,
  	}

    let parameters = {
			type:"touchStart",
			touchPoints: [touchPoint],
		}

		let timeout = randomIntRange(15,30);
    chrome.debugger.sendCommand({tabId: tabId}, "Input.dispatchTouchEvent", parameters, (results) => {
    	console.log("dispatched touchStart");
    	setTimeout(() => {
    		let newX = randomIntRange(1,5) - 3;
    		let newY = randomIntRange(1,5) - 3;
				parameters.type = "touchEnd";
				parameters.touchPoints[0].x = parameters.touchPoints[0].x + newX;
				parameters.touchPoints[0].y = parameters.touchPoints[0].y + newY;
		    chrome.debugger.sendCommand({tabId: tabId}, "Input.dispatchTouchEvent", parameters, (results) => {
		    	console.log("dispatched touchEnd");
		    	// chrome.debugger.detach({tabId: tabId},() => {
				  // 	console.log("detached");
				  // });
			  });
    	},timeout)
    })
  // });
}

const sendTouchCommand = async (tabId, x, y) => {
	console.log("tabId",tabId);
	console.log("x",x);
	console.log("y",y);

	chrome.debugger.attach({
			tabId: tabId
	}, "1.2", function(p) {
			chrome.debugger.sendCommand({
					tabId: r
			}, "Input.dispatchMouseEvent", {
					type: "mousePressed",
					x: x,
					y: y,
					button: "left",
					clickCount: 1
			}, () => {
					chrome.debugger.sendCommand({
							tabId: r
					}, "Input.dispatchMouseEvent", {
							type: "mouseReleased",
							x: x,
							y: y,
							button: "left",
							clickCount: 1
					}, () => {
							chrome.debugger.detach({
									tabId: __target
							}), console.log("y.")
					})
			})
	})
};

const sendTextCommand = (tabId, x, y, newText) => {
  chrome.debugger.attach({tabId: tabId}, "1.3", () => {
    let touchPoint = {
      x: x,
      y: y,
    }

    let parameters = {
      type: "touchStart",
      touchPoints: [touchPoint],
    }

    chrome.debugger.sendCommand({tabId: tabId}, "Input.dispatchTouchEvent", parameters, (results) => {
      setTimeout(() => {
        parameters.type = "touchEnd";
        chrome.debugger.sendCommand({tabId: tabId}, "Input.dispatchTouchEvent", parameters, (results) => {
          chrome.debugger.detach({tabId: tabId}, () => {
            chrome.tabs.executeScript(tabId, {
              code: `document.querySelector(".textarea__input").value = "${newText}";` +
                    `document.querySelector(".textarea__input").dispatchEvent(new Event('input', { bubbles: true }));` +
                    `document.querySelector(".textarea__input").dispatchEvent(new Event('change', { bubbles: true }));`
            });
          });
        });
      }, randomIntRange(5,30))
    })
  });
}





const randomIntRange = (min, max) => Math.floor(Math.random() * (max - min)) + min;


let availableLanguages = [
	"en",
	"ja",
	"ko",
	"de",
	"ru",
	"es",
	"pt",
	"pl",
	"fr",
	"it",
];

var localWindow = self;


chrome.runtime.onInstalled.addListener(function (object) {
	if(object.reason === 'install'){

		let lang = localWindow.navigator.languages ? localWindow.navigator.languages[0] : null;
	    lang = lang || localWindow.navigator.language || localWindow.navigator.browserLanguage || localWindow.navigator.userLanguage;

		let shortLang = lang;
		if (shortLang.indexOf('-') !== -1)
		    shortLang = shortLang.split('-')[0];

		if (shortLang.indexOf('_') !== -1)
		    shortLang = shortLang.split('_')[0];

		let link = "https://swiperino.com/welcome";
		if(availableLanguages.indexOf(shortLang) !== -1 && shortLang !== "en"){
			link = "https://"+shortLang+".swiperino.com/welcome";
		}
	}
});



if(chrome.runtime.setUninstallURL) {
	let lang = localWindow.navigator.languages ? localWindow.navigator.languages[0] : null;
	    lang = lang || localWindow.navigator.language || localWindow.navigator.browserLanguage || localWindow.navigator.userLanguage;

	let shortLang = lang;
	if (shortLang.indexOf('-') !== -1)
	    shortLang = shortLang.split('-')[0];

	if (shortLang.indexOf('_') !== -1)
	    shortLang = shortLang.split('_')[0];

	let link = "https://swiperino.com/uninstall";
	if(availableLanguages.indexOf(shortLang) !== -1 && shortLang !== "en"){
		link = "https://"+shortLang+".swiperino.com/uninstall";
	}

  chrome.runtime.setUninstallURL(link);
}



// const openNewTab = (link) => {
//   return new Promise((resolve, reject) => {
//     try {
//       chrome.tabs.create({url: link}, function(tab) {
//         resolve(tab.id);
//       });
//     } catch (error) {
//       reject(error);
//     }
//   });
// };



const toggleSwiperino = (apps,appActivity,swipeNumber,sleepTime,wakeTime) => {
	activeApps = apps;
	if(swiperinoStatus === "running"){
		swiperinoStatus = "idle";
		stopSwiperino();
		
	}else{
		swiperinoStatus = "running";
		startSwiperino(apps,appActivity,swipeNumber,sleepTime,wakeTime);
	}
	console.log("toggleSwiperino apps:",apps);
}


let interval = 0;
const startSwiperino = (apps,appActivity,swipeNumber,sleepTime,wakeTime) => {
	console.log("apps",apps);
	console.log("appActivity",appActivity);
	console.log("swipeNumber",swipeNumber);
	console.log("sleepTime",sleepTime);
	console.log("wakeTime",wakeTime);

	// apps:["tinder","bumble","badoo"]
	// appActivity 6
	// swipeNumber 50
	// sleepTime 2300
	// wakeTime 0700

	currentSettings = {
		apps,appActivity,swipeNumber,sleepTime,wakeTime
	}
	generateNewTasks();
	interval = setInterval(() => {
		processTask();
	},100)
	chrome.alarms.create('myPeriodicAlarm', {
    periodInMinutes: 0.05  // fire the alarm every 3 seconds
  });
}

const stopSwiperino = () => {
	if(interval !== 0){
		clearInterval(interval)
		interval = 0;
	}
	chrome.alarms.clear('myPeriodicAlarm', function(wasCleared) {
    if(wasCleared) {
			console.log("The alarm was successfully cleared");
    }else{
			console.log("No alarm by that name exists");
    }
	});
	// closeWindow();
}


let appActivityEnum = {
	1:{openAppRange: KlineIntervalEnum.MinuteOne * 240, duration: KlineIntervalEnum.MinuteOne * 8},
	2:{openAppRange: KlineIntervalEnum.MinuteOne * 150, duration: KlineIntervalEnum.MinuteOne * 8},
	3:{openAppRange: KlineIntervalEnum.MinuteOne * 75, duration: KlineIntervalEnum.MinuteOne * 8},
	4:{openAppRange: KlineIntervalEnum.MinuteOne * 45, duration: KlineIntervalEnum.MinuteOne * 10},
	5:{openAppRange: KlineIntervalEnum.MinuteOne * 30, duration: KlineIntervalEnum.MinuteOne * 15},
}

const generateNewTasks = () => {

	// Swipe 15% in morning
	// Swipe 25% in afternoon
	// Swipe 60% at night
	
	let {apps,appActivity,swipeNumber,sleepTime,wakeTime} = currentSettings;
	appActivity = parseInt(appActivity);
	if(isNaN(appActivity) || appActivity > 5 || appActivity < 1){
		appActivity = 3;
	}

	const sleepHour = parseInt(sleepTime.substring(0, 2));
	const sleepMinute = parseInt(sleepTime.substring(2, 4));
	const wakeHour = parseInt(wakeTime.substring(0, 2));
	const wakeMinute = parseInt(wakeTime.substring(2, 4));

	const currentDate = new Date();
	let sleepTimeStr = currentDate.getFullYear()+"-"+(currentDate.getMonth()+1)+"-"+currentDate.getDate()+" "+sleepHour+":"+sleepMinute+":00";
	let wakeTimeStr = currentDate.getFullYear()+"-"+(currentDate.getMonth()+1)+"-"+currentDate.getDate()+" "+wakeHour+":"+wakeMinute+":00";
	const sleepTimeDate = new Date(sleepTimeStr);
	const wakeTimeDate = new Date(wakeTimeStr);
	const todayWakeTimeDate = new Date(wakeTimeDate);
	wakeTimeDate.setDate(wakeTimeDate.getDate() + 1);

	sleepTimeDateGlobal = sleepTimeDate;
	wakeTimeDateGlobal = wakeTimeDate;

	taskList = [];
	let morningSwipeNumber = Math.round((swipeNumber*0.15)/apps.length);
	let afternoonSwipeNumber = Math.round((swipeNumber*0.25)/apps.length);
	let nightSwipeNumber = Math.round((swipeNumber*0.30)/apps.length);
	let lateNightSwipeNumber = Math.round((swipeNumber*0.30)/apps.length);
	morningSwipeNumber = getRandomInt(Math.round(morningSwipeNumber*.85),Math.round(morningSwipeNumber*1.15));
	afternoonSwipeNumber = getRandomInt(Math.round(afternoonSwipeNumber*.85),Math.round(afternoonSwipeNumber*1.15));
	nightSwipeNumber = getRandomInt(Math.round(nightSwipeNumber*.85),Math.round(nightSwipeNumber*1.15));
	lateNightSwipeNumber = getRandomInt(Math.round(lateNightSwipeNumber*.85),Math.round(lateNightSwipeNumber*1.15));

	let {openAppRange,duration} = appActivityEnum[appActivity];
	duration = duration/apps.length;

	let rollingTime = currentDate.getTime();
	let timesEnum = {Morning:"Morning",Noon:"Noon",Night:"Night",LateNight:"LateNight",}
	let addedTimes = {};

	taskList.push({ app:"swiperino", task:"pause", duration: KlineIntervalEnum.SecondOne * 1})
	for (let n = 0; n < 1000; n++) {
		for (let i = 0; i < apps.length; i++) {
			let app = apps[i];
			let localDuration = randomIntRange(duration * 0.8,duration * 1.2);
			let localDurationTwo = randomIntRange(duration * 0.8,duration * 1.2);
			let openWaitTime = KlineIntervalEnum.SecondOne * 12;
			let closeWaitTime = KlineIntervalEnum.SecondOne * 3;

			// localDuration = KlineIntervalEnum.SecondOne * 10;

			if(!(app in addedTimes)){addedTimes[app] = []}

			taskList.push({ app:app, task:"open", startTime: rollingTime, duration: openWaitTime,});

			if(rollingTime < (todayWakeTimeDate.getTime() + KlineIntervalEnum.HourOne) && addedTimes[app].indexOf(timesEnum.Morning) === -1 && morningSwipeNumber > 0){
				taskList.push({ app:app, task:"swipe", duration: localDurationTwo, amount: morningSwipeNumber});
				taskList.push({ app:app, task:"pause", duration: KlineIntervalEnum.SecondOne * 5, });
				addedTimes[app].push(timesEnum.Morning);
			}else if(new Date(rollingTime).getHours() >= 12 && new Date(rollingTime).getHours() <= 16 && addedTimes[app].indexOf(timesEnum.Noon) === -1 && afternoonSwipeNumber > 0){
				taskList.push({ app:app, task:"swipe", duration: localDurationTwo, amount: afternoonSwipeNumber});
				taskList.push({ app:app, task:"pause", duration: KlineIntervalEnum.SecondOne * 5, });
				addedTimes[app].push(timesEnum.Noon);
			}else if(rollingTime < (sleepTimeDate.getTime() - KlineIntervalEnum.HourOne * 4 && addedTimes[app].indexOf(timesEnum.Night) === -1) && nightSwipeNumber > 0){
				taskList.push({ app:app, task:"swipe", duration: localDurationTwo, amount: nightSwipeNumber});
				taskList.push({ app:app, task:"pause", duration: KlineIntervalEnum.SecondOne * 5, });
				addedTimes[app].push(timesEnum.Night);
			}else if(rollingTime < (sleepTimeDate.getTime() - KlineIntervalEnum.HourOne * 1 && addedTimes[app].indexOf(timesEnum.LateNight) === -1) && lateNightSwipeNumber > 0){
				taskList.push({ app:app, task:"swipe", duration: localDurationTwo, amount: lateNightSwipeNumber});
				taskList.push({ app:app, task:"pause", duration: KlineIntervalEnum.SecondOne * 5, });
				addedTimes[app].push(timesEnum.LateNight);
			}

			// taskList.push({ app:app, task:"swipe", duration: localDuration, amount: 3});
			// taskList.push({ app:app, task:"pause", duration: KlineIntervalEnum.SecondOne * 5, });
			// taskList.push({ app:app, task:"close", duration: closeWaitTime, });
			// taskList.push({ app:app, task:"open", startTime: rollingTime, duration: openWaitTime,});

			// if(app === "tinder"){
			// 	taskList.push({ app:app, task:"message-new-matches", duration: Math.round(localDuration/5),})
			// }
			taskList.push({ app:app, task:"message", duration: localDuration,})
			taskList.push({ app:app, task:"close", duration: closeWaitTime, });
		}

		if(rollingTime >= sleepTimeDate.getTime()){
			break;
		}
		rollingTime += randomIntRange(openAppRange * 0.85,openAppRange * 1.15);
	}

	taskList.push({ app:"swiperino", task:"sleep", startTime: sleepTimeDate, duration: KlineIntervalEnum.SecondOne * 3})
	taskList.push({ app:"swiperino", task:"wake", startTime: wakeTimeDate, duration: KlineIntervalEnum.SecondOne * 3})
	taskList.push({ app:"swiperino", task:"generate-new-task", duration: KlineIntervalEnum.SecondOne * 3})

}

const capitalizeFirstLetter = (string) => {
	return string.charAt(0).toUpperCase() + string.slice(1);
}

const processTask = () => {
	// console.log("processTask",new Date())
	if(taskList.length === 0){
		// console.log("tasklist empty");
		return;
	}

	let task = taskList[0];

	if(task.started === undefined){
		let currentTime = new Date().getTime();
		if(task.startTime !== undefined){
			let localStartTime = new Date(task.startTime).getTime();
			if(localStartTime > currentTime){
				let waitTime = localStartTime - currentTime
				// Waiting
				task.waitTime = waitTime
				return false;
			}
		}
		task.started = currentTime;
		task.ends = currentTime + task.duration;
		startTask(task);
		
	}else{
		if(task.ends < new Date().getTime()){
			console.log("remove task",task);
			taskList.shift();
			processTask();
		}
	}
}



const startTask = async (task) => {
	console.log("startTask task: ",task);
	let app = capitalizeFirstLetter(task.app);

	if(task.task === "open"){
		openTab(appEnum[app].Url)
	}else if(task.task === "close"){
		closeTab();
	}else if(task.task === "swipe"){
		nextCommand = {
			command: "ext-start-swipe",
			amount: task.amount,
		}
	}else if(task.task === "message"){
		nextCommand = {
			command: "ext-start-message",
		}
	}else if(task.task === "pause"){
		nextCommand = {
			command: "ext-pause",
		}
	}

}



// chrome.runtime.onInstalled.addListener(() => {
//   chrome.alarms.create('myPeriodicAlarm', {
//     periodInMinutes: 0.05  // fire the alarm every 1 minute
//   });
// });


chrome.alarms.onAlarm.addListener((alarm) => {
  if (alarm.name === 'myPeriodicAlarm') {
    console.log('The alarm was fired!',new Date(),"swiperinoStatus",swiperinoStatus);
  }
});


let currentOpenTabId = 0;
let currentOpenWindowId = 0;
const openTab = (url) => {
	if(currentOpenWindowId === 0){
		let openUrl = swiperinoDomain+"?w";
		console.log("openUrl",openUrl);
		chrome.windows.create({
			url: openUrl,width: 1120, height: 920, 
		}, function(window) {
			let newWindowId = window.id;
			currentOpenWindowId = newWindowId;
			setTimeout(() => {
				chrome.tabs.create({url: url, windowId: newWindowId}, function(tab) {
					currentOpenTabId = tab.id;
				});
			},150);
		});
	}else{
		chrome.tabs.create({url: url, windowId: currentOpenWindowId}, function(tab) {
			currentOpenTabId = tab.id;
		});
	}
}
const closeTab = () => {
	if(currentOpenTabId !== 0){
		chrome.tabs.remove(currentOpenTabId);
		currentOpenTabId = 0;
	}
}
const closeWindow = () => {
	if(currentOpenWindowId !== 0){
		chrome.windows.remove(currentOpenWindowId, function() {});
		currentOpenWindowId = 0;
	}
}
chrome.windows.onRemoved.addListener(function(windowId) {
  if (windowId === currentOpenWindowId) {
		currentOpenWindowId = 0;
  }
});

function getRandomInt(min, max) {
	min = Math.ceil(min);
	max = Math.floor(max);
	return Math.floor(Math.random() * (max - min + 1)) + min;
}